/*!
 * chartjs-plugin-streaming v1.9.0
 * https://nagix.github.io/chartjs-plugin-streaming
 * (c) 2017-2021 Akihiko Kusanagi
 * Released under the MIT license
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t(require("chart.js"),require("moment")):"function"==typeof define&&define.amd?define(["chart.js","moment"],t):(e="undefined"!=typeof globalThis?globalThis:e||self).ChartStreaming=t(e.Chart,e.moment)}(this,(function(e,t){"use strict";function a(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}var n=a(e),o=a(t),i=n.default.helpers,r=function(){if("undefined"!=typeof window)return window.cancelAnimationFrame||window.webkitCancelAnimationFrame||window.mozCancelAnimationFrame||window.oCancelAnimationFrame||window.msCancelAnimationFrame||function(e){return window.clearTimeout(e)}}(),s={resolveOption(e,t){var a=e.options.realtime,n=e.chart.options.plugins.streaming;return i.valueOrDefault(a[t],n[t])},startFrameRefreshTimer:function(e,t){if(!e.frameRequestID){var a=function(){t(),e.frameRequestID=i.requestAnimFrame.call(window,a)};e.frameRequestID=i.requestAnimFrame.call(window,a)}},stopFrameRefreshTimer:function(e){var t=e.frameRequestID;t&&(r.call(window,t),delete e.frameRequestID)}};function l(e,t,a){return null!=(n=t)&&("number"==typeof n?isFinite(n):n)?{value:e.getPixelForValue(t),transitionable:!0}:{value:a};var n}function u(){var e=n.default.Annotation.types.box,t=n.default.Annotation.types.line,a=e.prototype.configure,o=t.prototype.configure;e.prototype.configure=function(){var e,t,n,o,i,r,s,u,d,c,p,m,f;return i=(e=this).chartInstance,r=e.options,s=i.scales,u=i.chartArea,d=r.xScaleID,c=r.yScaleID,p=s[d],m=s[c],f=e._streaming={},p&&(t=l(p,r.xMin,u.left),n=l(p,r.xMax,u.right),o=t.value>n.value,t.transitionable&&(f[o?"right":"left"]={axisId:d}),n.transitionable&&(f[o?"left":"right"]={axisId:d})),m&&(t=l(m,r.yMin,u.top),n=l(m,r.yMax,u.bottom),o=t.value>n.value,t.transitionable&&(f[o?"bottom":"top"]={axisId:c}),n.transitionable&&(f[o?"top":"bottom"]={axisId:c})),a.call(this)},t.prototype.configure=function(){return function(e){var t=e.chartInstance,a=e.options,n=a.scaleID,o=a.value,i=t.scales[n],r=e._streaming={};if(i){var s=i.isHorizontal();l(i,o).transitionable&&(r[s?"x1":"y1"]={axisId:n},r[s?"x2":"y2"]={axisId:n},r[s?"labelX":"labelY"]={axisId:n})}}(this),o.call(this)}}var d={attachChart(e){var t=e.streaming;t.annotationPlugin||(u(),t.annotationPlugin=!0)},getElements(e){var t=e.annotation;if(t){var a=t.elements;return Object.keys(a).map((function(e){return a[e]}))}return[]},detachChart(e){delete e.streaming.annotationPlugin}},c=n.default.helpers,p=n.default.Zoom=n.default.Zoom||{};function m(e,t){if(e.scaleAxes&&e.rangeMax&&!c.isNullOrUndef(e.rangeMax[e.scaleAxes])){var a=e.rangeMax[e.scaleAxes];t>a&&(t=a)}return t}function f(e,t){if(e.scaleAxes&&e.rangeMin&&!c.isNullOrUndef(e.rangeMin[e.scaleAxes])){var a=e.rangeMin[e.scaleAxes];t<a&&(t=a)}return t}function h(e,t,a,n){var o,i,r=e.options.realtime,l=s.resolveOption(e,"duration"),u=s.resolveOption(e,"delay"),d=l*(2-t);o=e.isHorizontal()?(e.right-a.x)/(e.right-e.left):(e.bottom-a.y)/(e.bottom-e.top),i=t<1?m(n,d):f(n,d),r.duration=i,r.delay=u+o*(l-i)}function v(e,t,a){var n=e.options.realtime,o=s.resolveOption(e,"delay")+(e.getValueForPixel(t)-e.getValueForPixel(0));n.delay=t>0?m(a,o):f(a,o)}p.zoomFunctions=p.zoomFunctions||{},p.panFunctions=p.panFunctions||{};var g={attachChart(e){var t=e.streaming;t.zoomPlugin||(p.zoomFunctions.realtime=h,p.panFunctions.realtime=v,t.resetZoom=e.resetZoom,function(e){var t=e.$zoom||{_originalOptions:{}},a=e.resetZoom,n=e.update,o=function(){c.each(e.scales,(function(e){var a=e.options.realtime,n=t._originalOptions[e.id]||e.originalOptions;a&&(n?(a.duration=n.realtime.duration,a.delay=n.realtime.delay):(delete a.duration,delete a.delay))})),n.call(e,{duration:0})};e.resetZoom=function(){e.update=o,a(),e.update=n}}(e),t.zoomPlugin=!0)},detachChart(e){var t=e.streaming;t.zoomPlugin&&(e.resetZoom=t.resetZoom,delete t.resetZoom,delete t.zoomPlugin)}},y=n.default.helpers,x=y.canvas,b=n.default.scaleService,O=b.getScaleConstructor("time");b.getScaleConstructor=function(e){return"time"===e&&(e="realtime"),this.constructors.hasOwnProperty(e)?this.constructors[e]:void 0};var I=Number.MAX_SAFE_INTEGER||9007199254740991,w={millisecond:{common:!0,size:1,steps:[1,2,5,10,20,50,100,250,500]},second:{common:!0,size:1e3,steps:[1,2,5,10,15,30]},minute:{common:!0,size:6e4,steps:[1,2,5,10,15,30]},hour:{common:!0,size:36e5,steps:[1,2,3,6,12]},day:{common:!0,size:864e5,steps:[1,2,5]},week:{common:!1,size:6048e5,steps:[1,2,3,4]},month:{common:!0,size:2628e6,steps:[1,2,3]},quarter:{common:!1,size:7884e6,steps:[1,2,3,4]},year:{common:!0,size:3154e7}},_=Object.keys(w),A={parse:function(e,t){return"string"==typeof e&&"string"==typeof t?e=o.default(e,t):e instanceof o.default||(e=o.default(e)),e.isValid()?e.valueOf():null},add:function(e,t,a){return o.default(e).add(t,a).valueOf()},startOf:function(e,t,a){return e=o.default(e),"isoWeek"===t?e.isoWeekday(a).valueOf():e.startOf(t).valueOf()}};function D(e,t){if(y.isNullOrUndef(t))return null;var a=e.options.time,n=function(e,t){var a=e._adapter||A,n=e.options.time,o=n.parser,i=o||n.format,r=t;return"function"==typeof o&&(r=o(r)),("number"==typeof r||r instanceof Number)&&isFinite(r)||(r="string"==typeof i?a.parse(r,i):a.parse(r)),null!==r?+r:(o||"function"!=typeof i||("number"==typeof(r=i(t))||r instanceof Number)&&isFinite(r)||(r=a.parse(r)),r)}(e,e.getRightValue(t));return null===n||a.round&&(n=+(e._adapter||A).startOf(n,a.round)),n}function R(e,t,a,n){var o,i=e._adapter||A,r=e.options,s=r.time,l=s.unit||function(e,t,a,n){var o,i,r,s=_.length;for(o=_.indexOf(e);o<s-1;++o)if(r=(i=w[_[o]]).steps?i.steps[i.steps.length-1]:I,i.common&&Math.ceil((a-t)/(r*i.size))<=n)return _[o];return _[s-1]}(s.minUnit,t,a,n),u=function(e){for(var t=_.indexOf(e)+1,a=_.length;t<a;++t)if(w[_[t]].common)return _[t]}(l),d=y.valueOrDefault(s.stepSize,s.unitStepSize),c="week"===l&&s.isoWeekday,p=r.ticks.major.enabled,m=w[l],f=t,h=a,v=[];for(d||(d=function(e,t,a,n){var o,i,r,s=t-e,l=w[a],u=l.size,d=l.steps;if(!d)return Math.ceil(s/(n*u));for(o=0,i=d.length;o<i&&(r=d[o],!(Math.ceil(s/(u*r))<=n));++o);return r}(t,a,l,n)),c&&(f=+i.startOf(f,"isoWeek",c),h=+i.startOf(h,"isoWeek",c)),f=+i.startOf(f,c?"day":l),(h=+i.startOf(h,c?"day":l))<a&&(h=+i.add(h,1,l)),o=f,p&&u&&!c&&!s.round&&(o=+i.startOf(o,u),o=+i.add(o,~~((f-o)/(m.size*d))*d,l));o<h;o=+i.add(o,d,l))v.push(+o);return v.push(+o),v}var k=["pointBackgroundColor","pointBorderColor","pointBorderWidth","pointRadius","pointRotation","pointStyle","pointHitRadius","pointHoverBackgroundColor","pointHoverBorderColor","pointHoverBorderWidth","pointHoverRadius","backgroundColor","borderColor","borderSkipped","borderWidth","hoverBackgroundColor","hoverBorderColor","hoverBorderWidth","hoverRadius","hitRadius","radius","rotation"];function F(e){var t=e.realtime,a=t.refreshTimerID;a&&(clearInterval(a),delete t.refreshTimerID,delete t.refreshInterval)}function M(e){var t=e.realtime,a=s.resolveOption(e,"refresh");t.refreshTimerID=setInterval((function(){var a=s.resolveOption(e,"refresh");!function(e){var t,a,n,o,i,r,l,u=e.chart,d=e.id,c=s.resolveOption(e,"duration"),p=s.resolveOption(e,"delay"),m=s.resolveOption(e,"ttl"),f=s.resolveOption(e,"pause"),h=s.resolveOption(e,"onRefresh"),v=e.max,g=Date.now()-(isNaN(m)?c+p:m);h&&h(u),y.each(u.data.datasets,(function(s,c){if(t=u.getDatasetMeta(c),d===t.xAxisID||d===t.yAxisID){if(a=s.data,n=a.length,f){for(o=0;o<n&&e._getTimeForIndex(o,c)<v;++o);i=o+2}else i=0;for(o=i;o<n&&e._getTimeForIndex(o,c)<=g;++o);r=o-i,isNaN(m)&&(r=Math.max(r-2,0)),a.splice(i,r),y.each(k,(function(e){y.isArray(s[e])&&s[e].splice(i,r)})),y.each(s.datalabels,(function(e){y.isArray(e)&&e.splice(i,r)})),"object"!=typeof a[0]&&(l={start:i,count:r})}})),l&&u.data.labels.splice(l.start,l.count),u.update({preservation:!0})}(e),t.refreshInterval===a||isNaN(a)||(F(e),M(e))}),a),t.refreshInterval=a}function z(e,t,a){var n=e._start||{},o=e._view||{},i=e._model||{};y.each(e._streaming,((e,r)=>{e.axisId===t&&(n.hasOwnProperty(r)&&(n[r]-=a),o.hasOwnProperty(r)&&o!==n&&(o[r]-=a),i.hasOwnProperty(r)&&i!==o&&(i[r]-=a))}))}function C(e){var t,a,n=e.chart,o=e.realtime,i=e.id,r=s.resolveOption(e,"duration"),l=s.resolveOption(e,"delay"),u=e.isHorizontal(),c=u?e.width:e.height,p=Date.now(),m=e.options.ticks.reverse||!(u||"_reversePixels"in e),f=n.tooltip,h=d.getElements(n),v=c*(p-o.head)/r;for(u===m&&(v=-v),y.each(n.data.datasets,(function(e,o){var r=n.getDatasetMeta(o),s=r.data||[],l=r.dataset;for(t=0,a=s.length;t<a;++t)z(s[t],i,v);l&&z(l,i,v)})),t=0,a=h.length;t<a;++t)z(h[t],i,v);z(f,i,v),e.max=e._table[1].time=p-l,e.min=e._table[0].time=e.max-r,o.head=p}var T=O.extend({initialize:function(){var e=this;O.prototype.initialize.apply(e,arguments),("time"!==e.options.type||e.chart.options.plugins.streaming)&&(e.realtime=e.realtime||{},M(e))},update:function(){var e,t=this,a=t.realtime,n=t.options,o=n.bounds,i=n.distribution,r=n.offset,l=n.ticks,u=l.autoSkip,d=l.source,c=l.min,p=l.max,m=l.major,f=m.enabled;return"time"!==n.type||t.chart.options.plugins.streaming?(s.resolveOption(t,"pause")?s.stopFrameRefreshTimer(a):(s.startFrameRefreshTimer(a,(function(){C(t)})),a.head=Date.now()),n.bounds=void 0,n.distribution="linear",n.offset=!1,l.autoSkip=!1,l.source="auto"===d?"":d,l.min=-1e15,l.max=1e15,m.enabled=!0,e=O.prototype.update.apply(t,arguments),n.bounds=o,n.distribution=i,n.offset=r,l.autoSkip=u,l.source=d,l.min=c,l.max=p,m.enabled=f,e):O.prototype.update.apply(t,arguments)},buildTicks:function(){var e=this,t=e.options;if("time"===t.type&&!e.chart.options.plugins.streaming)return O.prototype.buildTicks.apply(e,arguments);var a,n=s.resolveOption(e,"duration"),o=s.resolveOption(e,"delay"),i=s.resolveOption(e,"refresh"),r=t.ticks,l=r.source,u=e._timestamps.data,d=e.realtime.head-o,c=d-n,p=[d+i,d];return""===l&&(r.source="data",e._timestamps.data=R(e,c,d+i,e.getLabelCapacity(c))),Object.defineProperty(e,"min",{get:function(){return c},set:y.noop}),Object.defineProperty(e,"max",{get:function(){return p.shift()},set:y.noop}),a=O.prototype.buildTicks.apply(e,arguments),delete e.min,delete e.max,e.min=c,e.max=d,""===l&&(r.source=l,e._timestamps.data=u),e._table=[{time:c,pos:0},{time:d,pos:1}],a},calculateTickRotation:function(){var e=this,t=e.options,a=t.ticks,n=a.maxRotation;"time"!==t.type||e.chart.options.plugins.streaming?(a.maxRotation=a.minRotation||0,O.prototype.calculateTickRotation.apply(e,arguments),a.maxRotation=n):O.prototype.calculateTickRotation.apply(e,arguments)},fit:function(){var e=this,t=e.options;O.prototype.fit.apply(e,arguments),("time"!==t.type||e.chart.options.plugins.streaming)&&t.ticks.display&&t.display&&e.isHorizontal()&&(e.paddingLeft=3,e.paddingRight=3,e.handleMargins())},draw:function(e){var t=this,a=t.chart;if("time"!==t.options.type||a.options.plugins.streaming){var n=t.ctx,o=t.isHorizontal()?{left:e.left,top:0,right:e.right,bottom:a.height}:{left:0,top:e.top,right:a.width,bottom:e.bottom};t._gridLineItems=null,t._labelItems=null,x.clipArea(n,o),O.prototype.draw.apply(t,arguments),x.unclipArea(n)}else O.prototype.draw.apply(t,arguments)},destroy:function(){var e=this;("time"!==e.options.type||e.chart.options.plugins.streaming)&&(s.stopFrameRefreshTimer(e.realtime),F(e))},_getTimeForIndex:function(e,t){var a,n=this,o=n._timestamps,i=o.datasets[t][e];return y.isNullOrUndef(i)&&(a=n.chart.data.datasets[t].data[e],i=y.isObject(a)?D(n,a):D(n,o.labels[e])),i}});b.registerScaleType("realtime",T,{position:"bottom",distribution:"linear",bounds:"data",adapters:{},time:{parser:!1,unit:!1,round:!1,displayFormat:!1,isoWeekday:!1,minUnit:"millisecond",displayFormats:{millisecond:"h:mm:ss.SSS a",second:"h:mm:ss a",minute:"h:mm a",hour:"hA",day:"MMM D",week:"ll",month:"MMM YYYY",quarter:"[Q]Q - YYYY",year:"YYYY"}},realtime:{},ticks:{autoSkip:!1,source:"auto",major:{enabled:!0}}});var P=n.default.helpers,S=P.canvas;function E(e,t,a){var n={};return P.each(t.x,(function(e){n[e]={axisId:a.xAxisID}})),P.each(t.y,(function(e){n[e]={axisId:a.yAxisID}})),n}n.default.defaults.global.plugins.streaming={duration:1e4,delay:0,frameRate:30,refresh:1e3,onRefresh:null,pause:!1,ttl:void 0},n.default.defaults.global.legend.onClick=function(e,t){var a=t.datasetIndex,n=this.chart,o=n.getDatasetMeta(a);o.hidden=null===o.hidden?!n.data.datasets[a].hidden:null,n.update({duration:0})};var N={x:["x","controlPointPreviousX","controlPointNextX","caretX"],y:["y","controlPointPreviousY","controlPointNextY","caretY"]};function Y(e){var t,a,o,i,r,s,l=this,u=e&&e.preservation;u&&(t=l.tooltip,a=l.lastActive,o=t._lastActive,l._bufferedRender=!0,(r=l.legend)&&(s=r.update,r.update=P.noop)),n.default.prototype.update.apply(l,arguments),u&&(l._bufferedRender=!1,l._bufferedRequest=null,l.lastActive=a,t._lastActive=o,r&&(r.update=s),l.animating?n.default.animationService.animations.forEach((function(e){e.chart===l&&l.render({duration:16.66*(e.numSteps-e.currentStep)})})):l.data.datasets.forEach((function(e,t){l.getDatasetMeta(t).controller.transition(1)})),t._active&&t.update(!0),(i=l.streaming.lastMouseEvent)&&l.eventHandler(i))}function j(){var e,t=this,a=t._active&&t._active[0];return a?(e=t._chart.getDatasetMeta(a._datasetIndex),t._streaming=E(0,N,e)):t._streaming={},n.default.Tooltip.prototype.update.apply(t,arguments)}var q={id:"streaming",beforeInit:function(e){var t=e.streaming=e.streaming||{},a=t.canvas=e.canvas,n=t.mouseEventListener=function(a){var n=P.getRelativePosition(a,e);t.lastMouseEvent={type:"mousemove",chart:e,native:a,x:n.x,y:n.y}};a.addEventListener("mousedown",n),a.addEventListener("mouseup",n)},afterInit:function(e){e.update=Y,e.tooltip.update=j},beforeUpdate:function(e){var t=e.options,a=t.scales;return a&&P.each(a.xAxes.concat(a.yAxes),(function(e){"realtime"!==e.type&&"time"!==e.type||(t.elements.line.capBezierPoints=!1)})),e.annotation?d.attachChart(e):d.detachChart(e),e.resetZoom?g.attachChart(e):g.detachChart(e),!0},afterUpdate:function(e){var t=e.streaming,a=!0;!function(e){P.each(e.data.datasets,(function(t,a){var n,o,i=e.getDatasetMeta(a),r=i.data||[],s=i.dataset;for(n=0,o=r.length;n<o;++n)r[n]._streaming=E(r[n],N,i);s&&(s._streaming=E(0,N,i))}))}(e),P.each(e.scales,(function(e){e instanceof T&&(a&=s.resolveOption(e,"pause"))})),a?s.stopFrameRefreshTimer(t):s.startFrameRefreshTimer(t,(function(){!function(e){var t=e.streaming,a=e.options.plugins.streaming.frameRate,n=1e3/(Math.max(a,0)||30),o=t.lastDrawn+n||0,i=Date.now(),r=t.lastMouseEvent;o<=i&&(e.animating||e.tooltip._start||e.draw(),r&&e.eventHandler(r),t.lastDrawn=o+n>i?o:i)}(e)}))},beforeDatasetDraw:function(e,t){var a=t.meta,n=e.chartArea,o={left:0,top:0,right:e.width,bottom:e.height};return a.xAxisID&&a.controller.getScaleForId(a.xAxisID)instanceof T&&(o.left=n.left,o.right=n.right),a.yAxisID&&a.controller.getScaleForId(a.yAxisID)instanceof T&&(o.top=n.top,o.bottom=n.bottom),S.clipArea(e.ctx,o),!0},afterDatasetDraw:function(e){S.unclipArea(e.ctx)},beforeEvent:function(e,t){var a=e.streaming;return"mousemove"===t.type?a.lastMouseEvent=t:"mouseout"===t.type&&delete a.lastMouseEvent,!0},destroy:function(e){var t=e.streaming,a=t.canvas,n=t.mouseEventListener;s.stopFrameRefreshTimer(t),delete e.update,delete e.tooltip.update,a.removeEventListener("mousedown",n),a.removeEventListener("mouseup",n),P.each(e.scales,(function(e){e instanceof T&&e.destroy()}))}};return n.default.helpers.streaming=s,n.default.plugins.register(q),q}));
